import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

public class FileInteractor {

	private String filename;
	private FileWriter fileout;
	private BufferedWriter filebuf;
	private PrintWriter printout;
	private BufferedReader reader;	
	
	public FileInteractor(String filename) throws IOException {
		
		this.filename = filename;
		this.fileout = new FileWriter(filename, true);
        this.filebuf = new BufferedWriter(fileout);
        this.printout = new PrintWriter(filebuf);
		this.reader = new BufferedReader(new FileReader(filename));
        
	}
	
	public void log(String type, String code) {
		
		String current = new SimpleDateFormat("dd-MM-yyyy").format(new Date());
		this.write(type + ", " + current + ", " + code);
		
	}
	
	public void removeLine(int lineNumber) throws IOException {
		
		File inputFile = new File(filename);

		int index = 0;
		String currentLine, toWrite = "";
		while((currentLine = this.reader.readLine()) != null) {
			index++;
		    String trimmedLine = currentLine.trim();
		    System.out.println(trimmedLine);
		    if(index == lineNumber) {
		    	System.out.println("Line: " + index);
		    	continue;
		    }
		    toWrite = currentLine + System.getProperty("line.separator");
		}
		this.reader.close(); 
		System.out.print(toWrite);
		FileWriter rewrite = new FileWriter(filename, false); // no append
		BufferedWriter buf = new BufferedWriter(rewrite);
		PrintWriter printer = new PrintWriter(buf);
		printer.print(toWrite);
		printer.close();
		
	}
	
	public void increaseByCode(String code, int howMany) {
		
		try{
        File file = new File(filename);
        BufferedReader reader = new BufferedReader(new FileReader(file));
        String line = "", oldtext = "", yes = "";
        while((line = reader.readLine()) != null)
            {
        	if(line.split(",")[0].trim().equals(code.trim()))
        		yes = line;
        	
            oldtext += line + "\r\n";
        }
        reader.close();
        
        String[] arr = yes.split(",");
        int currentQuantity = Integer.parseInt(arr[2].trim());
        int newQuantity = currentQuantity + howMany;
        String newtext = oldtext.replaceAll("[\b"+code+"\b].+", arr[0] + ", " + arr[1] + ", " + newQuantity + ", " + arr[3] + ", " + arr[4] + ", " + arr[5]);
        FileWriter writer = new FileWriter(filename);
        writer.write(newtext);
        writer.close();
    }
    catch (IOException ioe)
        {
        ioe.printStackTrace();
    }
		
	}
	
	public void write(String string) {
		
		System.out.println(string);
		this.printout.print(string);
		this.printout.close();
		
	}
	
}
