import java.io.IOException;
import java.util.ArrayList;

public class Warehouse {
	
	private static ArrayList<Product> products;
	
	public Warehouse() {
		
		products = new ArrayList<Product>();
		
	}
	
	public void addToInitialize(Product p) {
		products.add(p);
	}
	
	public static boolean exists(String code) {
		
		for(int i = 0, len = products.size(); i < len; i++) {
			
			if(products.get(i).getCode().trim().equals(code.trim()))
				return true;
			
		}
		
		return false;
		
	}
	
	public static String[] toArray() {
		
		String a = "";
		
		for(int i = 0, len = products.size(); i < len; i++) {
			
			a += products.get(i).getCode() + ",";
			
		}
		
		return a.split(",");
		
	}
	
	public String[] below() {
		
		String returnable = "";
		
		for(int i = 0, len = products.size(); i < len; i++) {
			
			Product current = products.get(i);
			if(current.getQuantity() < current.getMinimum())
				returnable += current.getCode() + ",";
				
		}
		
		String[] actual = returnable.split(",");
		return actual;
		
	}
	
	public static int getLineByCode(String code) {
		
		for(int i = 0, len = products.size(); i < len; i++) {
			
			if(products.get(i).getCode().equals(code))
				return i + 1;
			
		}
		return 0;
		
	}
	
	public static void removeByCode(String code) {
		
		for(int i = 0, len = products.size(); i < len; i++) {
			
			if(products.get(i).getCode().equals(code)) {
				products.remove(products.get(i));
				return;
			}
			
		}
		
	}
	
	public static void increaseByCode(String code, int howMuch) {
		
		for(int i = 0, len = products.size(); i < len; i++) {
			Product current = products.get(i);
			if(current.getCode().equals(code))
				current.setQuantity(howMuch + current.getQuantity());
			
		}
		
		return;
		
	}
	
	public boolean insertProduct(Product p) throws IOException {
			
		for(int i = 0, len = products.size(); i < len; i++) {
			
			System.out.println(products.get(i).getCode());
			if(products.get(i).getCode().equals(p.getCode()))  
				return false;
			
			
		}
		
		// String code, String name, int quantity, int minimum, double u_cost
		FileInteractor writer = new FileInteractor("files/warehouse.csv");
		writer.write(p.getCode() + ", " + p.getName() + ", " + p.getQuantity() + ", " + p.getMinimum() + ", " + p.getSingleCost() + ", " + p.getFinalCost() + "\n");		
		products.add(p);
		return true;
		
	}
	
}
